var Alarms_settings = {
   Debug:   0,                                                          //Livello di log (0 = Error, 1 = Debug, 2 = Verbose)
   Tag:     "Server.Tags.Alarms_JSON",                                  //Variabile da usare per _inviare_ le informazioni ai pannelli
   Groups:  [                                                           //Elenco gruppi
               //["Quadro PT",0xFF0000FF],                                //["Nome grouppo",RGBA]
               ["Quadro Zone Comuni (Q5.1)",0x808000FF],
               ["Quadro Contatore Uffici ECA Tecnologie (Q1.1)",0x808000FF],
               ["Quadro Uffici ECA Tecnologie (Q1.2)",0x808000FF],
               ["Quadro Contatore Showroom (Q2.1)",0x808000FF],
               ["Quadro Showroom (Q2.2)",0x808000FF],
               ["Allagamento",0x8080FFFF],
               ["Antincendio",0xFF0000FF],
               ["Tiranti Bagno",0xFF8000FF]
            ],
   Alarms:  [                                                           //Elenco degli allarmi
               //["Drivers.KNX.Tags.All1",0,"Mancanza rete ENEL"],        //["Variabile",Gruppo,"Testo allarme"]     
               ["Drivers.KNX.Tags.Q5_1 - Scatto Int_ Ascensore",0,"Scatto Int. Ascensore"],
               ["Drivers.KNX.Tags.Q5_1 - Scatto Int_ Linea PT",0,"Scatto Int. Linea PT"],
               ["Drivers.KNX.Tags.Q5_1 - Scatto Int_ Linea UPS",0,"Scatto Int. Linea UPS"],
               ["Drivers.KNX.Tags.Q5_1 - Scatto Int_ Rack Dati",0,"Scatto Int. Rack Dati"],
               ["Drivers.KNX.Tags.Q1_1 - Scatto Int_ Q1_2",1,"Scatto Int. Q1.2"],
               ["Drivers.KNX.Tags.Q1_2 - Scatto Int_ Linea UPS",2,"Scatto Int. Linea UPS"],
               ["Drivers.KNX.Tags.Q1_2 - Scatto Int_ Rack Dati",2,"Scatto Int. Rack Dati"],
               ["Drivers.KNX.Tags.Q2_1 - Scatto Int_ Q2_2",3,"Scatto Int. Q2.2"],
               ["Drivers.KNX.Tags.Q2_2 - Scatto Int_ Linea UPS",4,"Scatto Int. Linea UPS"],
               ["Drivers.KNX.Tags.Q2_2 - Scatto Int_ Rack Dati",4,"Scatto Int. Rack Dati"],
               ["Drivers.KNX.Tags.Comuni - Allagamento",5,"Allarme Allagamento"],
               ["Drivers.KNX.Tags.Comuni - Fumo Loc_ Caldaia",6,"Allarme Fumo Loc. Caldaia"],
               ["Drivers.KNX.Tags.Comuni - Fumo Loc_ Quadri",6,"Allarme Fumo Loc. Quadri"],
               ["Drivers.KNX.Tags.U1 - Tirante Bagno",7,"Tirante Bagno Uffici ECA Tecnologie"]
            ]
}

//AlarmModule(settings);
var Alarms = new AlarmModule(Alarms_settings);


// Evento di verifica del cambio delle variabili
// ATTENZIONE: Puo' esistere _un solo_ listener di questo tipo!
//             Nel caso ci siano piu' script che necessitano di questo evento, sara' necessario unificarlo.
IR.SetGlobalListener(IR.EVENT_GLOBAL_TAG_CHANGE, function (name, value)
{
   Alarms.check(name,value);
});
//-----------------------------------------------------------------
function AlarmModule(settings){
   var DEBUG = settings.Debug != null ? settings.Debug : 0;
   var varName = settings.Tag;
   
   //["Nome grouppo",RGBA,0]
   var Group =  settings.Groups;
   for(i in Group) Group[i].push(0);
   fLog("Group: " + JSON.Stringify(Group),2);
   
   
   //["Variabile",Gruppo,"Testo allarme",0,"",""]
   //Composizione array
   //0 - Path completo della variabile di allarme
   //1 - Indice del gruppo di appartenenza relativa all'array Group (inizia da 0)
   //2 - Testo dell'allarme che verra' visualizzato sui client
   //3 - Stato dell'allarme (0 = OK / 1 = Allarme)
   //4 - Ora di attivazione dell'allarme
   //5 - Ora di disattivazione dell'allarme
          
   var List = settings.Alarms;
   for(i in List) List[i].push(0,"","");
   fLog("List: " + JSON.Stringify(List),2);

   //Funzione che gestisce la scrittura sul log 
   function fLog(text,level){
      level = level != null ? level : 0;
      if(DEBUG != 0 && DEBUG >= level) IR.Log("Alarms > " + text);
   }

   var lastIndex = -1;
    
   //Listener per sottoscrivere le variabili interessate
   IR.AddListener(IR.EVENT_START,0,function(){
      for(i=0;i<List.length;i++) IR.SubscribeTagChange(List[i][0]);
   });
   
   //Listener per cancellare la sottoscrizione delle variabili utilizzate
   IR.AddListener(IR.EVENT_EXIT,0,function(){
      for(i=0;i<List.length;i++) IR.SubscribeTagChange(List[i][0]);
   });

   
   //Listener per eseguire il check allarmi ad ogni cambio delle variabili locali
   this.check = function(name,value){
      for(i=0;i<List.length;i++){
         if(name == List[i][0]){
            fLog("Tag changed",1);
            fLog(name + ">" + value,1);
            var i;
            
            fLog("Check for " + name + " = " + value,2);
            
            for(i=0; i<List.length;i++){
               if(name == List[i][0]){
                  var date = new Date();
                  var time = date.getDate() + "/" + date.getMonth() + "/" + date.getFullYear() + " - " + date.getHours() + ":" + (date.getMinutes() < 10 ? "0":"") + date.getMinutes();
                  if(value == 0) {
                     List[i][3] = 0;
                     List[i][5] = time;
                     for(m=0;m<List.length;m++) if(List[i][1] == List[m][1] && List[m][3] == 1) m = List.length + 1;
                     if(m == List.length) Group[List[i][1]][2] = 0;
                  }
                  if(value == 1) {
                     List[i][3] = 1;
                     List[i][4] = time;
                     List[i][5] = "";
                     lastIndex = i;    
                     Group[List[i][1]][2] = 1;        
                  }               
               }   
            }
            
            fLog("Array = " + List,2);
            fLog("lastIndex = " + lastIndex,2);
            
            //Creo la base dell'oggetto JSON
            var json = JSON.Stringify({"alarms":{"group":[],"active":[],"last":{}}});
            json = JSON.Parse(json);
            
            //Inserisco i gruppi
            for(i=0; i<Group.length;i++)
               json.alarms.group.push({"name":Group[i][0],"color":Group[i][1],"state":Group[i][2]});
            
            //Inserisco la lista degli allarmi attivi
            var alarm = 0;
            for(i=0;i<List.length;i++)
               if(List[i][3] == 1)
                  json.alarms.active.push({"group":List[i][1],"text":List[i][2],"time_on":List[i][4],"time_off":List[i][5]});
            
            //Inserisco i dati dell'ultimo allarme avvenuto
            if(lastIndex != -1){
               json.alarms.last.group = List[lastIndex][1];
               json.alarms.last.text = List[lastIndex][2];
               json.alarms.last.time_on = List[lastIndex][4];
               json.alarms.last.time_off = List[lastIndex][5];
            }
            
            //Trasformo l'oggetto JSON in stringa per poterlo passare ai client
            json = JSON.Stringify(json);
            fLog("json = " + json,2);
            
            IR.SetVariable(varName,json);
            i = List.length;
         }
      }
   }
}