
var Trend_settings = {
   Debug:   0,                                                                   //Livello di log (0 = Error, 1 = Debug, 2 = Verbose)
   VarList: [                                                                    //Elenco delle variabili
               //["KNX.UPS - Energy","Server.Tags.Fotovoltaico - Energy Bar"],   //Variabile di ricerca,Variabile di output
               ["KNX.U1 - Energia Generale","Server.Tags.U1 Generale - Energy Bar"],
               ["KNX.U1 - Energia PdC","Server.Tags.U1 PdC - Energy Bar"],
               ["KNX.U2 - Energia Generale","Server.Tags.U2 Generale - Energy Bar"],
               ["KNX.U2 - Energia PdC","Server.Tags.U2 PdC - Energy Bar"],
               ["KNX.Comuni - Energia Generale","Server.Tags.Comuni Generale - Energy Bar"]
            ]
}

//AlarmModule(settings);
var Trend = new TrendModule(Trend_settings);
//-----------------------------------------------------------------
function TrendModule(settings){
   var DEBUG = settings.Debug != null ? settings.Debug : 0;
   
   //Funzione che gestisce la scrittura sul log 
   function fLog(text,level){
      level = level != null ? level : 0;
      if(DEBUG != 0 && DEBUG >= level) IR.Log("Trend > " + text);
   }
   
   var sql = IR.GetDatabase();
              
   IR.AddListener(IR.EVENT_START,0,function(){
      IR.SetTimeout(1*60*1000,Refresh);   //Aggiornamento all'avvio ritardato per dare il tempo al sistema di acquisire i dati dal campo
      //Refresh();
      IR.SetInterval(24*60*60*1000+60000,Refresh); // i 60000 aggiuntivi sono per dare il tempo al server di registrare i dati ad inizio giornata
   });
   
   function Refresh(){
      var date = new Date();
      var query,req;
      var day;
      
      fLog("Aggiornamento",1);
      for (variabile=0;variabile<settings.VarList.length;variabile++) {
         var varName = settings.VarList[variabile][0];
         var varJSON = settings.VarList[variabile][1];
         
         fLog("Aggiornamento '" + varJSON + "' coi dati di '" + varName + "'",1);
         
         var json = {
               unit: {day : [1,"kWh"],month : [1,"kWh"],year : [1000,"MWh"]},   //Valori KNX in kWh
               day:[],
               month:[],
               year:[],
               start:{day:0,month:0,year:0}
              }; 
                 
         //Day
         day = date.getFullYear() + "-" +
               (date.getMonth()+1 < 10 ? "0" : "") + (date.getMonth()+1) + "-" +
               (date.getDate() < 10 ? "0" : "") + date.getDate();
         for(i=28;i>=0;i--){  //Impostare il numero di giorni da caricare
            query = 'Select Query2.Date As Date, (Query1.Value - Query2.Value) /' + json.unit.day[0] + ' As Value From' +
                        ' (Select FLOAT_TAG_HISTORY.VALUE As Value From'+
                           ' FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                           ' And Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2, "+'+i+' day") = "'+day+'" Order By main.FLOAT_TAG_HISTORY.DATETIME Limit 1) Query1,'+
                        ' (Select strftime("%d-%m",main.FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2) As Date, FLOAT_TAG_HISTORY.VALUE As Value From'+
                           ' FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                           ' And Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2, "+'+(i+1)+' day") = "'+day+'" Order By FLOAT_TAG_HISTORY.DATETIME Limit 1) Query2';
            fLog("Query = " + query,2);
            req = sql.Request(query);
            fLog("Rows = " + req.Rows,2);
            fLog("Row(0): " + req.GetRowValue(0,0) + " = " + req.GetRowValue(1,0),2);
            
            if(req.Rows > 0) json.day.push({"date" : req.GetRowValue(0,0),"value" : req.GetRowValue(1,0)});                        
         }
         query = 'Select VALUE From FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                     ' And Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2) = "'+day+'" Order By FLOAT_TAG_HISTORY.DATETIME Limit 1';
         fLog("Query = " + query,2);
         var req = sql.Request(query);
         fLog("Rows = " + req.Rows,2);
         fLog("Row(0): " + req.GetRowValue(0,0),2);
         
         if(req.Rows > 0) json.start.day = req.GetRowValue(0,0);
                  
         
         //Month
         day = date.getFullYear() + "-" +
               (date.getMonth()+1 < 10 ? "0" : "") + (date.getMonth()+1);
         for(i=10;i>=0;i--){
            query = 'Select Query2.Date As Date, (Query1.Value - Query2.Value) /' + json.unit.month[0] + ' As Value From' +
                        ' (Select FLOAT_TAG_HISTORY.VALUE As Value From'+
                           ' FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                           ' And strftime("%Y-%m",Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2, "+'+i+' month")) = "'+day+'" Order By main.FLOAT_TAG_HISTORY.DATETIME Limit 1) Query1,'+
                        ' (Select strftime("%m-%Y",main.FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2) As Date, FLOAT_TAG_HISTORY.VALUE As Value From'+
                           ' FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                           ' And strftime("%Y-%m",Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2, "+'+(i+1)+' month")) = "'+day+'" Order By FLOAT_TAG_HISTORY.DATETIME Limit 1) Query2';
            fLog("Query = " + query,2);
            req = sql.Request(query);
            fLog("Rows = " + req.Rows,2);
            fLog("Row(0): " + req.GetRowValue(0,0) + " = " + req.GetRowValue(1,0),2);
            
            if(req.Rows > 0) json.month.push({"date" : req.GetRowValue(0,0),"value" : req.GetRowValue(1,0)});                        
         }
         query = 'Select VALUE From FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                     ' And strftime("%Y-%m",Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2)) = "'+day+'" Order By FLOAT_TAG_HISTORY.DATETIME Limit 1';
         fLog("Query = " + query,2);
         var req = sql.Request(query);
         fLog("Rows = " + req.Rows,2);
         fLog("Row(0): " + req.GetRowValue(0,0),2);
         
         if(req.Rows > 0) json.start.month = req.GetRowValue(0,0);
         
         //Year
         day = date.getFullYear();      
         for(i=8;i>=0;i--){
            query = 'Select Query2.Date As Date, (Query1.Value - Query2.Value) /' + json.unit.year[0] + ' As Value From' +
                        ' (Select FLOAT_TAG_HISTORY.VALUE As Value From'+
                           ' FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                           ' And strftime("%Y",Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2, "+'+i+' year")) = "'+day+'" Order By main.FLOAT_TAG_HISTORY.DATETIME Limit 1) Query1,'+
                        ' (Select strftime("%Y",main.FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2) As Date, FLOAT_TAG_HISTORY.VALUE As Value From'+
                           ' FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                           ' And strftime("%Y",Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2, "+'+(i+1)+' year")) = "'+day+'" Order By FLOAT_TAG_HISTORY.DATETIME Limit 1) Query2';
            fLog("Query = " + query,2);
            req = sql.Request(query);
            fLog("Rows = " + req.Rows,2);
            fLog("Row(0): " + req.GetRowValue(0,0) + " = " + req.GetRowValue(1,0),2);
            
            if(req.Rows > 0) json.year.push({"date" : req.GetRowValue(0,0),"value" : req.GetRowValue(1,0)});                        
         }
         query = 'Select VALUE From FLOAT_TAG_HISTORY Inner Join TAGS_PASSPORT On TAGS_PASSPORT.TAG_ID = FLOAT_TAG_HISTORY.TAG_ID Where main.TAGS_PASSPORT.NAME = "'+varName+'"'+
                     ' And strftime("%Y",Date(FLOAT_TAG_HISTORY.DATETIME + 15020 + 2400000.5 - 2)) = "'+day+'" Order By FLOAT_TAG_HISTORY.DATETIME Limit 1';
         fLog("Query = " + query,2);
         var req = sql.Request(query);
         fLog("Rows = " + req.Rows,2);
         fLog("Row(0): " + req.GetRowValue(0,0),2);
         
         if(req.Rows > 0) json.start.year = req.GetRowValue(0,0);
         
         fLog("json = " + JSON.Stringify(json),2);      
         IR.SetVariable(varJSON,JSON.Stringify(json));
      }
   }
}
