var WeatherWidget = new WeatherFunction("20254979ad094654990110110172106","Pegognaga,IT");
//-----------------------------------------------------------------
function WeatherFunction(Key,City){
   //Variable declaration
   var Device = IR.CreateDevice(IR.DEVICE_CUSTOM_HTTP_TCP,"WorldWeatherOnline","api.worldweatheronline.com",80);
   var RefreshNum = 0;
   var RefreshTimeout;
   var GlobalJSON = "";
   
   var DisableDayAutoRefresh = 0;
   
   function clearVar(){
      //Routine per la cancellazione delle variabili relative al meteo
   }
   
   function Refresh(){
      //IR.Log("Weather > Refresh request");
      City = City.replace(",","%2C");
      City = City.replace("-","%2D");
      var command = "GET,/premium/v1/weather.ashx?key=" + Key + "&format=json&num_of_days=3&tp=24&q=" + City;
      clearVar();
      
      if(RefreshNum <= 3){
         IR.SetVariable("Server.Tags.Weather_Location","Connessione(" + RefreshNum + ")...");
         Device.Send([command]);
         RefreshTimeout = IR.SetTimeout(5000,Refresh);  
      } else {
         IR.SetVariable("Server.Tags.Weather_Location","Impossibile contattare il server");
      }   
   } 

   function LinkImage(code,type) {
     var link = "";
          
     switch(parseInt(code,10)) {
         case 113:
            code = 32;
            break;
         case 116:
            code = 34;
            break;
         case 119:
            code = 29;
            break;
         case 122:   
            code = 26;
            break;
         case 143:
         case 248:
            code = 20;
            break;
         case 176:
         case 263:
         case 293:
            code = 9;
            break;
         case 179:
         case 323:
         case 329:
         case 335:
            code = 14;
            break;
         case 182:  
         case 185:
         case 281:
         case 284:
         case 317:
         case 320:
         case 362:
         case 365: 
            code = 5;
            break;
         case 200:
            code = 47;
            break;
         case 227:
            code = 16;
            break;
         case 230:
            code = 13;
            break;
         case 260:
         case 311:
         case 314:
         case 350:
            code = 7;
            break;
         case 266:
         case 296:            
         case 353:      
            code = 11;
            break;
         case 299:
         case 305:
            code = 12;
            break;
         case 302:
         case 308:
         case 356:
         case 359:
            code = 10;
            break;
         case 326:   
         case 332:
         case 338:
         case 368:
         case 371:
            code = 41;
            break;
         case 374:
            code = 6;
            break;
         case 377:
            code = 18;
            break;
         case 386:
            code = 38;
            break;
         case 389:
            code = 3;
            break;
         case 392:
         case 395:
            code = 35;
            break;           
         default:
            code = 0;
     }
           
     switch(code) {
         case 27:
         case 29:
         case 31:
         case 33:
            code += "n";
            break;
         default:
            code += "d";
      }
      
      switch(parseInt(type,10)) {
         case 1:  //Background                    
            //link = "";//"http://cdn.worldweatheronline.net/images/weather/small/" + code + "_day_sm.png";
            link = "http://l.yimg.com/os/mit/media/m/weather/images/icons/bkgnd/" + code + "-106755.jpg";
            break;
         case 0:  //Picture
         default:
            //link = "http://cdn.worldweatheronline.net/images/weather/small/" + code + "_day_sm.png"; 
            link = "http://l.yimg.com/os/mit/media/m/weather/images/icons/l/" + code + "-100567.png";
      }

      if(code == "0d") link = "";
      return link;
   }
   
   function ValidateDate(date){
      var result = "";
      
      date = date.split("-");
      
      result += date[2];
      switch(parseInt(date[1],10)){
         case(1):
            result += " Gennaio";
            break;
         case(2):
            result += " Febbraio";
            break;
         case(3):
            result += " Marzo";
            break;
         case(4):
            result += " Aprile";
            break;              
         case(5):
            result += " Maggio";
            break;
         case(6):
            result += " Giugno";
            break;
         case(7):
            result += " Luglio";
            break;
         case(8):
            result += " Agosto";
            break;
         case(9):
            result += " Settembre";
            break;
         case(10):
            result += " Ottobre";
            break;
         case(11):
            result += " Novembre";
            break;
         case(12):
            result += " Dicembre";
            break;
         default:
            result = "????"
      }
      return result;      
   } 
   
   function process(data){
      //IR.Log("Weather:  Received data");

      GlobalJSON += data;
      //IR.Log(GlobalJSON);
      if(GlobalJSON.indexOf("}}") != -1){
        //IR.Log(GlobalJSON);
         IR.ClearInterval(RefreshTimeout);         //Change: Move from row ~203
         
         var json = JSON.Parse(GlobalJSON);
         
         if(!json.data){
            IR.SetVariable("Server.Tags.Weather_Location","Nessuna informazione disponibile");
         } else {
            if(json.data.hasOwnProperty("error")){
               IR.SetVariable("Server.Tags.Weather_Location","Errore");
               for(e = 0; e < json.data.error.length; e++){
                  IR.Log("Weather > Error #" + e + ": " + json.data.error[e].msg);
                  if(json.data.error[e].msg == "API key has reached calls per day allowed limit.") DisableDayAutoRefresh = IR.GetVariable("System.Date.Day"); //Change: Add control for stop auto refresh when call limit si reached
               }
            } else {
               IR.SetVariable("Server.Tags.Weather_Location",json.data.request[0].query);
               IR.SetVariable("Server.Tags.Weather_Humidity",json.data.current_condition[0].humidity + "%");
               IR.SetVariable("Server.Tags.Weather_Pressure",json.data.current_condition[0].pressure + " mb");
               IR.SetVariable("Server.Tags.Weather_Visibility",json.data.current_condition[0].visibility + " Km");
               IR.SetVariable("Server.Tags.Weather_Sunrise",json.data.weather[0].astronomy[0].sunrise);
               IR.SetVariable("Server.Tags.Weather_Sunset",json.data.weather[0].astronomy[0].sunset);
               IR.SetVariable("Server.Tags.Weather_WindSpeed",json.data.current_condition[0].windspeedKmph + " Km/h");
               IR.SetVariable("Server.Tags.Weather_TodayIcon",LinkImage(json.data.weather[0].hourly[0].weatherCode,0));
               IR.SetVariable("Server.Tags.Weather_TodayBackground",LinkImage(json.data.weather[0].hourly[0].weatherCode,1));
               IR.SetVariable("Server.Tags.Weather_TodayDate",ValidateDate(json.data.weather[0].date));
               IR.SetVariable("Server.Tags.Weather_TodayTemp",json.data.current_condition[0].temp_C + "°C");
               IR.SetVariable("Server.Tags.Weather_TodayMin",json.data.weather[0].mintempC + "°C");
               IR.SetVariable("Server.Tags.Weather_TodayMax",json.data.weather[0].maxtempC + "°C");
               
               for(i = 2;i > 0;i--){
                  IR.SetVariable("Server.Tags.Weather_Day" + i +"Icon",LinkImage(json.data.weather[i].hourly[0].weatherCode,0));
                  IR.SetVariable("Server.Tags.Weather_Day" + i +"Background",LinkImage(json.data.weather[i].hourly[0].weatherCode,1));
                  IR.SetVariable("Server.Tags.Weather_Day" + i +"Date",ValidateDate(json.data.weather[i].date));
                  IR.SetVariable("Server.Tags.Weather_Day" + i +"Min",json.data.weather[i].mintempC + "°C");
                  IR.SetVariable("Server.Tags.Weather_Day" + i +"Max",json.data.weather[i].maxtempC + "°C");
               }
            }
         }
         GlobalJSON = "";
      }                          
   }     
   
   IR.AddListener(IR.EVENT_RECEIVE_TEXT,Device,function(text){process(text);});
   
   IR.AddListener(IR.EVENT_START,0,function(){
      //IR.Log("Weather > Start");
      RefreshNum = 0;
      Refresh();
   });   

   IR.SetInterval(1000*60*60*3,function(){
      if(IR.GetVariable("System.Date.Day") != DisableDayAutoRefresh) DisableDayAutoRefresh = 0;
      
      //IR.Log("Weather > Auto Refresh" + (DisableDayAutoRefresh ? " Disable" : ""));
      if(DisableDayAutoRefresh == 0){  //Check if i can do a new call for refresh data
         RefreshNum = 0;
         Refresh();
      }
   });
   
   this.ManualRefresh = function(){
      //IR.Log("Weather > Manual Refresh");
      RefreshNum = 0;
      Refresh();
   }   
}